<?php
// No direct access to this file
defined('_JEXEC') or die;


jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

class com_falangInstallerScript
{

        /** @var array The list of extra modules and plugins to install */
        private $installation_queue = array(
            // modules => { (folder) => { (module) => { (position), (published) } }* }*
            'modules' => array(
                'site' => array(
                    'falang' => array('position-7', 1)
                )
            ),
             // plugins => { (folder) => { (element) => (published) }* }*
            'plugins' => array(
                'system' => array(
                    'falangdriver'				=> 1,
                    'falangquickjump'		=> 1
                )
            )
        );

        // plugins => { (folder) => { (element) => (published) }* }*
        private $installation_params = array(
           'components' => array(
                       'falang' => array(
                           'frontEndEdition'  => 0,
                           'show_list'  => 1,
                           'show_form' => 1,
                           'component_list' => 'com_content#content#id#task#!edit#10#13com_categories#categories#id#task#!edit#10#13com_menus#menu#id#task#!edit#10#13com_modules#modules#id#task#!edit#client#!1#10#13com_newsfeeds#newsfeeds#id#task#!edit'
                   )
           )
        );

        /** @var array Obsolete files and folders to remove from the Core release only */
        private $falangRemoveFilesFree = array(
            'files'	=> array(
                'administrator/components/com_falang/views/translate/tmpl/popup.php'
            ),
            'folders' => array()
        );

    private $falangRemoveFilesPaid = array(
        'files'	=> array(
            'administrator/components/com_falang/views/translate/tmpl/popup_free.php'
        ),
        'folders' => array()
    );


    function install($parent)
        {
        }

        function uninstall($parent)
        {
        }

        function update($parent)
        {
        }

        function preflight($type, $parent)
        {
        }

        function postflight($type, $parent)
        {
                JLoader::import('joomla.filesystem.file');
                include_once( JPATH_ADMINISTRATOR . '/components/com_falang/version.php');
                $version = new FalangVersion();

                $isFalangFree = $version->_versiontype == 'free'?true:false;
                if($isFalangFree) {
                    $falangRemoveFiles = $this->falangRemoveFilesFree;
                } else {
                    $falangRemoveFiles = $this->falangRemoveFilesPaid;
                }
                $this->_removeObsoleteFilesAndFolders($falangRemoveFiles);

                $status = $this->_installSubextensions($parent);
                $this->_setDefaultParams($type);
        }


        private function _installSubextensions($parent) {
                $src = $parent->getParent()->getPath('source');

                $db = JFactory::getDbo();

                $status = new JObject();
                $status->modules = array();
                $status->plugins = array();

                // Falang use native joomla installation package for components, modules and plugins
                // Modules configuration
                if(count($this->installation_queue['modules'])) {
                        foreach($this->installation_queue['modules'] as $folder => $modules) {
                                if(count($modules)) foreach($modules as $module => $modulePreferences) {
                                        // Was the module already installed?
                                        $sql = $db->getQuery(true)
                                            ->select('COUNT(*)')
                                            ->from('#__modules')
                                            ->where($db->qn('module') . ' = ' . $db->q('mod_' . $module));
                                        $db->setQuery($sql);
                                        $count = $db->loadResult();
                                        // Modify where it's published and its published state
                                        if(!$count) {
                                                // A. Position and state
                                                list($modulePosition, $modulePublished) = $modulePreferences;

                                                $sql = $db->getQuery(true)
                                                    ->update($db->qn('#__modules'))
                                                    ->set($db->qn('position').' = '.$db->q($modulePosition))
                                                    ->where($db->qn('module').' = '.$db->q('mod_'.$module));
                                                if($modulePublished) {
                                                        $sql->set($db->qn('published').' = '.$db->q('1'));
                                                }
                                                $db->setQuery($sql);
                                                $db->query();

                                                // C. Link to all pages
                                                $query = $db->getQuery(true);
                                                $query->select('id')->from($db->qn('#__modules'))
                                                    ->where($db->qn('module').' = '.$db->q('mod_'.$module));
                                                $db->setQuery($query);
                                                $moduleid = $db->loadResult();

                                                $query = $db->getQuery(true);
                                                $query->select('*')->from($db->qn('#__modules_menu'))
                                                    ->where($db->qn('moduleid').' = '.$db->q($moduleid));
                                                $db->setQuery($query);
                                                $assignments = $db->loadObjectList();
                                                $isAssigned = !empty($assignments);
                                                if(!$isAssigned) {
                                                        $o = (object)array(
                                                            'moduleid'	=> $moduleid,
                                                            'menuid'	=> 0
                                                        );
                                                        $db->insertObject('#__modules_menu', $o);
                                                }

                                        }

                                }


                        }
                }

                // Falang use native joomla installation package for components, modules and plugins
                // Plugins publish
                if(count($this->installation_queue['plugins'])) {
                        foreach ($this->installation_queue['plugins'] as $folder => $plugins) {
                                if (count($plugins)) foreach ($plugins as $plugin => $published) {
                                        // Was the plugin already installed?
//                                        $query = $db->getQuery(true)
//                                            ->select('COUNT(*)')
//                                            ->from($db->qn('#__extensions'))
//                                            ->where($db->qn('element').' = '.$db->q($plugin))
//                                            ->where($db->qn('folder').' = '.$db->q($folder));
//                                        $db->setQuery($query);
//                                        $count = $db->loadResult();
//                                    if($published && !$count) {
                                        if($published ) {
                                                $query = $db->getQuery(true)
                                                    ->update($db->qn('#__extensions'))
                                                    ->set($db->qn('enabled').' = '.$db->q('1'))
                                                    ->where($db->qn('element').' = '.$db->q($plugin))
                                                    ->where($db->qn('folder').' = '.$db->q($folder));
                                                $db->setQuery($query);
                                                $db->query();
                                        }
                                }
                        }

                }
                return $status;
        }

        private function _setDefaultParams($type){


                $db = JFactory::getDBO();
                $updateParams = false;

                if(count($this->installation_params['components'])) {
                        foreach ($this->installation_params['components'] as $folder => $components) {
                                if (count($components)) {
                                    $sql = $db->getQuery(true)
                                        ->select($db->qn('params'))
                                        ->from($db->qn('#__extensions'))
                                        ->where($db->qn('element') . " = " . $db->q('com_' . $folder));
                                    $db->setQuery($sql);
                                    $config_ini = $db->loadResult();

                                    $config_ini = json_decode($config_ini, true);
                                    if (empty($config_ini)){$config_ini=array();}

                                    foreach ($components as $componentParams => $value) {

                                        if (!array_key_exists($componentParams, $config_ini)) {
                                            //set value to key
                                            $config_ini[$componentParams] = $value;
                                            $updateParams = true;
                                        }

                                    }
                                    //update params
                                    if ($updateParams) {
                                        $query = $db->getQuery(true);
                                        $query->update($db->quoteName('#__extensions'));
                                        $parameter = new JRegistry;
                                        $parameter->loadArray($config_ini);
                                        $defaults = json_encode($config_ini); // JSON format for the parameters
                                        $defaults = str_replace('#10#13','\r\n',$defaults);
                                        $query->set($db->quoteName('params') . ' = ' . $db->q($defaults));
                                        $query->where($db->quoteName('name') . ' = ' . $db->q('com_' . $folder));
                                        $db->setQuery($query);
                                        $db->query();
                                    }
                                }
                        }
                }




        }

    /**
     * Removes obsolete files and folders
     *
     * @param array $falangRemoveFiles
     */
    private function _removeObsoleteFilesAndFolders($falangRemoveFiles)
    {
        // Remove files
        jimport('joomla.filesystem.file');
        if(!empty($falangRemoveFiles['files'])) foreach($falangRemoveFiles['files'] as $file) {
            $f = JPATH_ROOT.'/'.$file;
            if(!JFile::exists($f)) continue;
            JFile::delete($f);
        }

        // Remove folders
        jimport('joomla.filesystem.file');
        if(!empty($falangRemoveFiles['folders'])) foreach($falangRemoveFiles['folders'] as $folder) {
            $f = JPATH_ROOT.'/'.$folder;
            if(!JFolder::exists($f)) continue;
            JFolder::delete($f);
        }
    }
}
